<?php
/*
Element Description: Rs Team Box
*/
     
    // Element Mapping
     function vc_portfolio_slider_mapping() {
         
        // Stop all if VC is not enabled
        if ( !defined( 'WPB_VC_VERSION' ) ) {
            return;
        }
        $category_dropdown = array( __( 'All Categories', 'bstart' ) => '0' );	
        $args = array(
                    'taxonomy' => array('portfolio-category'),//ur taxonomy
                    'hide_empty' => false,                  
            );

		$terms_= new WP_Term_Query( $args );
		foreach ( (array)$terms_->terms as $term ) {
			$category_dropdown[$term->name] = $term->slug;		
		}

         
        // Map the block with vc_map()
        vc_map( 
            array(
                'name' => __('Rs Portfolio Slider', 'bstart'),
                'base' => 'vc_rsPortfolioslider',
                'description' => __('Rs Portfolio Information', 'bstart'), 
                'category' => __('by RS Theme', 'bstart'),   
                'icon' => get_template_directory_uri().'/framework/assets/img/vc-icon.png',           
                'params' => array(

                	array(
                		"type" => "dropdown",
                		"heading" => __("Style", 'bstart'),
                		"param_name" => "slider_style",
                		"value" => array(	
                			__('Style 1', 'bstart') => "style1", 
                			__('Style 2', 'bstart') => "style2", 
                		),
                		'description' => __( 'Select your portfolio slider style here.', 'bstart' ),                		
                	),	   
                         
                    array(
						"type" => "dropdown",
						"heading" => __("Show title", "bstart"),
						"param_name" => "title",
						"value" => array(							    						
							'Yes' => "Yes", 
							'No' => "No",																																										
						),
						
					),                     
             	
					
					array(
						"type" => "dropdown",
						"heading" => __("Show Short Description", 'bstart'),
						"param_name" => "description",
						"value" => array(	
						    						
							'Yes' => "Yes", 
							'No' => "No", 																																															
						),
						
					),	
					
					array(
						"type" => "textfield",
						"heading" => __("Portfolio Per Pgae", "bstart"),
						"param_name" => "team_per",
						'value' =>"6",
						'description' => __( 'You can write how many team member show. ex(2)', 'bstart' ),					
					),	


					array(
					"type" => "dropdown_multi",
					"holder" => "div",
					"class" => "",
					"heading" => __( "Categories", 'bstart' ),
					"param_name" => "cat",
					'value' => $category_dropdown,
					),


				
					array(
					"type" => "dropdown",
					"holder" => "div",
					"class" => "",
					"heading" => __( "Number of columns ( Desktops > 1199px )", 'bstart' ),
					"param_name" => "col_lg",
					"value" => array(							
								'1' => "1", 
								'2' => "2",
								'3' => "3",	
								'4' => "4",
								'5' => "5",
								'6' => "6",																						
							),
					"std" => "3",
					"group" 	  => __( "Slider Options", 'bstart' ),
					
					),
				array(
					"type" => "dropdown",
					"holder" => "div",
					"class" => "",
					"heading" => __( "Number of columns ( Desktops > 991px )", 'bstart' ),
					"param_name" => "col_md",
					"value" => array(							
								'1' => "1", 
								'2' => "2",
								'3' => "3",	
								'4' => "4",
								'5' => "5",
								'6' => "6",																						
							),
					"std" => "3",
					"group" 	  => __( "Slider Options", 'bstart' ),
					
					),
				array(
					"type" => "dropdown",
					"holder" => "div",
					"class" => "",
					"heading" => __( "Number of columns ( Tablets > 767px )", 'bstart' ),
					"param_name" => "col_sm",
					"value" => array(							
								'1' => "1", 
								'2' => "2",
								'3' => "3",	
								'4' => "4",
								'5' => "5",
								'6' => "6",																						
							),
					"std" => "2",
					"group" 	  => __( "Slider Options", 'bstart' ),
					
					),
				array(
					"type" => "dropdown",
					"holder" => "div",
					"class" => "",
					"heading" => __( "Number of columns ( Phones < 768px )", 'bstart' ),
					"param_name" => "col_xs",
					"value" => array(							
								'1' => "1", 
								'2' => "2",
								'3' => "3",	
								'4' => "4",
								'5' => "5",
								'6' => "6",																						
							),
					"std" => "1",
					"group" 	  => __( "Slider Options", 'bstart' ),
					
					),
				array(
					"type" => "dropdown",
					"holder" => "div",
					"class" => "",
					"heading" => __( "Number of columns ( Small Phones < 480px )", 'bstart' ),
					"param_name" => "col_mobile",
					"value" => array(							
								'1' => "1", 
								'2' => "2",
								'3' => "3",	
								'4' => "4",
								'5' => "5",
								'6' => "6",																						
							),
					"std" => "1",
					"group" 	  => __( "Slider Options", 'bstart' ),
					
					),

					array(
					"type" => "dropdown",
					"holder" => "div",
					"class" => "",
					"heading" => __( "Navigation Dots", 'bstart' ),
					"param_name" => "slider_dots",
					"value" => array(
						__( 'Disabled', 'bstart' ) => 'false',
						__( 'Enabled', 'bstart' )  => 'true',
						),
					"description" => __( "Enable or disable navigation dots. Default: Disable", 'bstart' ),
					"group" => __( "Slider Options", 'bstart' ),
					
					
					),
				array(
					"type" => "dropdown",
					"holder" => "div",
					"class" => "",
					"heading" => __( "Autoplay", 'bstart' ),
					"param_name" => "slider_autoplay",
					"value" => array( 
						__( "Enable", "bstart" )  => 'true',
						__( "Disable", "bstart" ) => 'false',
						),
					"description" => __( "Enable or disable autoplay. Default: Enable", 'bstart' ),
					"group" => __( "Slider Options", 'bstart' ),
					
					),
				array(
					"type" => "dropdown",
					"holder" => "div",
					"class" => "",
					"heading" => __( "Stop on Hover", 'bstart' ),
					"param_name" => "slider_stop_on_hover",
					"value" => array( 
						__( "Enable", "bstart" )  => 'true',
						__( "Disable", "bstart" ) => 'false',
						),
					'dependency' => array(
						'element' => 'slider_autoplay',
						'value'   => array( 'true' ),
						),
					"description" => __( "Stop autoplay on mouse hover. Default: Enable", 'bstart' ),
					"group" => __( "Slider Options", 'bstart' ),
					
					),

				array(
					"type" 		  => "dropdown",
					"holder" 	  => "div",
					"class" 	  => "",
					"heading" 	  => __( "Autoplay Interval", 'bstart' ),
					"param_name"  => "slider_interval",
					"value" 	  => array( 
						__( "5 Seconds", "bstart" )  => '5000',
						__( "4 Seconds", "bstart" )  => '4000',
						__( "3 Seconds", "bstart" )  => '3000',
						__( "2 Seconds", "bstart" )  => '4000',
						__( "1 Seconds", "bstart" )  => '1000',
						),
					'dependency'  => array(
						'element' => 'slider_autoplay',
						'value'   => array( 'true' ),
						),
					"description" => __( "Set any value for example 5 seconds to play it in every 5 seconds. Default: 5 Seconds", 'bstart' ),
					"group" 	  => __( "Slider Options", 'bstart' ),
					
					),
				array(
					"type"		  => "textfield",
					"holder" 	  => "div",
					"class" 	  => "",
					"heading" 	  => __( "Autoplay Slide Speed", 'bstart' ),
					"param_name"  => "slider_autoplay_speed",
					"value" 	  => 200,
					'dependency'  => array(
						'element' => 'slider_autoplay',
						'value'   => array( 'true' ),
						),
					"description" => __( "Slide speed in milliseconds. Default: 200", 'bstart' ),
					"group" 	  => __( "Slider Options", 'bstart' ),
					
					),	
				array(
					"type" 		 => "dropdown",
					"holder" 	 => "div",
					"class" 	 => "",
					"heading" 	 => __( "Loop", 'bstart' ),
					"param_name" => "slider_loop",
					"value" 	 => array( 
						__( "Enable", "bstart" )  => 'true',
						__( "Disable", "bstart" ) => 'false',
						),
					"description"=> __( "Loop to first item. Default: Enable", 'bstart' ),
					"group" 	 => __( "Slider Options", 'bstart' ),
					
					),

					array(
					'type' => 'css_editor',
					'heading' => __( 'CSS box', 'bstart' ),
					'param_name' => 'css',
					'group' => __( 'Design Options', 'bstart' ),
				),            
                        
                ),
				
					
            )
        );                                   
    }
     
   add_action( 'vc_before_init', 'vc_portfolio_slider_mapping' );
     
    // Element HTML
     function vc_portfolioslider_html( $atts,$content ) {
         $attributes = array();
        // Params extraction
        extract(
            shortcode_atts(
                array(
					'title'                 => '',
					'slider_style'          => '',
					'cat'                   => '',	
					'description'           => '',	
					'team_per'              => '6',				
					'icon_fontawesome'      => 'fa fa-users',					
					'col_lg'                => '3',
					'col_md'                => '3',
					'col_sm'                => '2',
					'col_xs'                => '1',
					'col_mobile'            => '1',
					'slider_nav'            => 'true',
					'slider_dots'           => 'false',
					'slider_autoplay'       => 'true',
					'slider_stop_on_hover'  => 'true',
					'slider_interval'       => '5000',
					'slider_autoplay_speed' => '200',
					'slider_loop'           => 'true',				
					'css'                   => ''            
                ), 
                $atts,'vc_rsPortfolioslider'
           )
        );
	
        $a = shortcode_atts(array(
            'screenshots' => 'screenshots',
        ), $atts);

        $img = wp_get_attachment_image_src($a["screenshots"], "large");
        $imgSrc = $img[0];
		
		//extract content
		$atts['content'] = $content;

		//extact icon 
		$iconClass = isset( ${'icon_fontawesome'} ) ? esc_attr( ${'icon_fontawesome'} ) : 'fa fa-users';
		//extract css edit box
		$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, vc_shortcode_custom_css_class( $css, ' ' ), $atts ); 

		$owl_data = array( 
			'nav'                => ( $slider_nav === 'true' ) ? true : false,
			'navText'            => array( "<i class='fa fa-angle-left'></i>", "<i class='fa fa-angle-right'></i>" ),
			'dots'               => ( $slider_dots === 'false' ) ? false : true,
			'autoplay'           => ( $slider_autoplay === 'true' ) ? true : false,
			'autoplayTimeout'    => $slider_interval,
			'autoplaySpeed'      => $slider_autoplay_speed,
			'autoplayHoverPause' => ( $slider_stop_on_hover === 'true' ) ? true : false,
			'loop'               => ( $slider_loop === 'true' ) ? true : false,
			'margin'             => 20,
			'responsive'         => array(
				'0'    => array( 'items' => $col_mobile ),
				'480'  => array( 'items' => $col_xs ),
				'768'  => array( 'items' => $col_sm ),
				'992'  => array( 'items' => $col_md ),
				'1200' => array( 'items' => $col_lg ),
				)				
			);
		$owl_data = json_encode( $owl_data );	           


        
		$html='<div class="rs-portfolio '.$slider_style.'">
		<div class="team-carousel owl-carousel owl-navigation-yes" data-carousel-options="'.esc_attr( $owl_data ).'">';		
		$post_title_show='';
		$degination='';
		$description_team='';
			
        //******************//
        // query post
        //******************//

        	 	$arr_cats=array();
                $arr= explode(',', $cat);
					for ($i=0; $i < count($arr) ; $i++) { 
	               	//$cats = get_term_by('slug', $arr[$i], $taxonomy);
	               	// if(is_object($cats)):
	               	$arr_cats[]= $arr[$i];
	               	//endif;
	            }	            
			   $best_wp = new wp_Query(array(
					'post_type' => 'portfolios',
					'posts_per_page' =>$team_per,
					'tax_query' => array(
				        array(
				            'taxonomy' => 'portfolio-category',
				            'field' => 'slug', //can be set to ID
				            'terms' => $arr_cats//if field is ID you can reference by cat/term number
				        ),
				    )
				));				     
		
			while($best_wp->have_posts()): $best_wp->the_post();
			   $post_title= get_the_title($best_wp->ID);
			   
			    if($title!='No'){
			   		 $post_title_show= get_the_title($best_wp->ID);
				}		
						
			    $post_img_url = get_the_post_thumbnail($best_wp->ID,'portfolio-slider');
			    $post_url=get_post_permalink($best_wp->ID); 
				
						    
				if($description!='No'){
			    $description_team = get_post_meta( get_the_ID(), 'description', true );
				}
			   				
				//retrive social icon values
				
				$facebook = get_post_meta( get_the_ID(), 'facebook', true );
				$twitter = get_post_meta( get_the_ID(), 'twitter', true );
				$google_plus = get_post_meta( get_the_ID(), 'google_plus', true );
				$linkedin = get_post_meta( get_the_ID(), 'linkedin', true );
				$fb='';
				$tw='';
				$gp='';
				$ldin='';	

				if($facebook!=''){
					$fb='<a href="'.$facebook.'" class="social-icon"><i class="fa fa-facebook"></i></a> ';
				}
				if($twitter!=''){
					$tw='<a href="'.$twitter.'" class="social-icon"><i class="fa fa-twitter"></i></a>';
				}
				if($google_plus!=''){
					$gp='<a href="'.$google_plus.'" class="social-icon"><i class="fa fa-google-plus"></i></a> ';
				}
				if($linkedin!=''){
					$ldin='<a href="'.$linkedin.'" class="social-icon"><i class="fa fa-pinterest-p"></i></a>';
				}				 
			

				$html .='<div class="portfolio-slider">
				    <div class="portfolio-item content-overlay">
                        <div class="portfolio-img">
                           '.$post_img_url.'
                        </div>
                        <div class="portfolio-content">
                            <div class="display-table">
                                <div class="display-table-cell">                                  
                                    <h3 class="p-title"><a href="'.$post_url.'">'.$post_title_show.'</a></h3>
                                    <a href="'.$post_url.'" class="readon">View Details</a>
                                </div>
                            </div>
                        </div>
                    </div>
				</div>';
			
		endwhile; 
       	wp_reset_query();
		$html .='</div>
	   <div>
	 </div>
	</div>'
	;
    return $html; 
 
}

add_shortcode( 'vc_rsPortfolioslider', 'vc_portfolioslider_html' );