<?php
function guten_post_layout_render_post_grid( $attributes ){
	
	
	$recent_posts = wp_get_recent_posts( array(
		'post_type' => $attributes['post_type'],
		'numberposts' => $attributes['postscount'],
		'post_status' => $attributes['post_type'] === 'attachment' ? 'inherit' : 'publish',
		'order'       => $attributes['order'],
		'orderby'     => $attributes['orderBy'],
		'category'    => isset($attributes['categories']) ? $attributes['categories'] : '',
	));
	

	if ( count( $recent_posts ) === 0 ) {
		return;
	}
	
	$markup = '';

	$widthClass = (isset($attributes['postBlockWidth']) && $attributes['postBlockWidth'] ) ? 'align'.$attributes['postBlockWidth'] : '';
	
	if( $attributes['postLayout'] === 'slides'){
		
		$random_number = rand(10, 1000);
		$markup .= sprintf('<div id="gpl-slick-slider-'.esc_attr($random_number).'" class="gpl-slick-slider '.esc_attr($widthClass).'" data-count="%1$d" data-slides-to-show="%2$s" data-autoplay="%3$s" data-navigation="%4$s">', count( $recent_posts ), $attributes['slidesToShow'], $attributes['autoPlay'], $attributes['navigation']);
		
		$markup .= sprintf('<div  class="gpl-post-slider-one wp-block-guten-post-layout-post-grid post-grid-view gpl-d-flex gpl-flex-wrap" data-layout="%1$s" style="--item-padding-left-right : '.$attributes['columnGap'].'px; --item-margin-bottom : '.($attributes['columnGap']*2).'px; --item-height : '.(300-$attributes['columnGap']).'px" >', $attributes['carouselLayoutStyle']);
		
		foreach ( $recent_posts as $post ){
			$post_id = $post['ID'];
			$post_thumbnail_id = get_post_thumbnail_id($post_id);

			$gridView = $attributes['postLayout'] === 'grid' ? 'post-item gpl-mb-30 gpl-column-'.$attributes['columns'].'' : 'post-item gpl-mb-30';

			$image = $attributes['post_type'] === 'attachment' ? $post['guid'] : wp_get_attachment_image_src( $post_thumbnail_id, '' . $attributes['postImageSizes'] . '', false)[0];
			
			$hasImage = $image ? 'has-image' : '';
			$contentHasImage = $image ? 'content-has-image' : '';

			// start the post-item wrap
			$markup .= sprintf( '<article class="%1$s %2$s">', esc_attr($gridView), $attributes['carouselLayoutStyle'] );
			// start the post content wrap
			$markup .= '<div class="post-content-area ' . $attributes['align'] . ' '.$hasImage.'">';

			if( $attributes['displayPostImage'] && $image ) {
				$markup .= sprintf( '<div class="post-image"><a href="%1$s" target="_blank" rel="bookmark"><img src="%2$s"/></a></div>',
					esc_url( get_permalink( $post_id ) ),
					$image
				);
			}

			// start the inner post content wrap
			$markup .= '<div class="gpl-inner-post-content '.$contentHasImage.'">';

			// start the post meta wrap
			$markup .= '<div class="post-meta">';

			if( isset($attributes['displayPostAuthor']) && $attributes['displayPostAuthor'] && $attributes['carouselLayoutStyle'] !== 'g_skin2' ) {
				$markup .= sprintf(
					'<a target="_blank" href="%2$s">%1$s</a>',
					esc_html( get_the_author_meta( 'display_name', $post['post_author'] ) ),
					esc_url( get_author_posts_url( get_author_posts_url( $post['post_author'] ) ) )
				);
			}

			if( isset($attributes['displayPostDate']) && $attributes['displayPostDate'] ) {
				$markup .= sprintf(
					'<time datetime="%1$s">%2$s</time>',
					esc_attr( get_the_date( 'c', $post_id ) ),
					esc_html( get_the_date( '', $post_id ) )
				);
			}

			$markup .= '</div>';
			// close the post meta wrap

			// start the post title wrap
			$markup .= sprintf( '<h2 class="post-title"><a href="%1$s" target="_blank" rel="bookmark">%2$s</a></h2>',
				esc_url( get_permalink($post_id) ),
				esc_html( get_the_title($post_id)) );
			// close the post title wrap

			// start the post excerpt wrap
			$content = get_the_excerpt( $post_id );
			if( $content && $attributes['displayPostExcerpt'] && $attributes['carouselLayoutStyle'] !== 'g_skin1' && $attributes['carouselLayoutStyle'] !== 'g_skin2' ) {
				$markup .= sprintf( ' <div class="post-excerpt"><div><p>%1$s</p></div></div>',
					wp_kses_post( $content )
				);
			}
			// close the post excerpt wrap

			// start the post read more wrap
			if( isset($attributes['displayPostReadMoreButton']) && $attributes['displayPostReadMoreButton'] && $attributes['carouselLayoutStyle'] !== 'g_skin1' && $attributes['gridLayoutStyle'] !== 'g_skin2') {
				$markup .= sprintf( '<div><a class="post-read-moore" href="%1$s" target="_blank" rel="bookmark">%2$s</a></div>', esc_url( get_permalink( $post_id ) ),esc_html( $attributes['postReadMoreButtonText'] ) );
			}
			// close the post read more wrap

			$markup .= '</div>';
			$markup .= '<div class="gpl-overlay-effect"></div>';
			$markup .= '</div>';
			// close the post content wrap

			$markup .= '</article>';
			// close the post-item wrap
		}
		$markup .= '</div>';
		$markup .= '</div>';
	}

	
	if( $attributes['postLayout'] !== 'slides') {

		$firstPostItem = count($recent_posts) > 0 && $attributes['gridLayoutStyle'] === 'g_skin2' ? array_splice($recent_posts, 0, 1) : '';

		$gridViewWrapper = $attributes['postLayout'] === 'list' ? 'wp-block-guten-post-layout-post-grid post-grid-view gpl-d-flex gpl-flex-wrap list-layout' : 'wp-block-guten-post-layout-post-grid post-grid-view gpl-d-flex gpl-flex-wrap';
		
		
		$markup .= sprintf( '<div class="%1$s %2$s %3$s" style="--item-padding-left-right : '.$attributes['columnGap'].'px; --item-margin-bottom : '.($attributes['columnGap']*2).'px; --item-height : '.(300-$attributes['columnGap']).'px">', esc_attr( $gridViewWrapper ), $attributes['gridLayoutStyle'], $widthClass );
		if ( $firstPostItem ) {
			$post_id           = $firstPostItem[0]['ID'];
			$post_thumbnail_id = get_post_thumbnail_id( $post_id );
			$post              = $firstPostItem[0];

			// start the post-item wrap
			$markup .= '<div class="gpl-column-4">';

			$gridView = $attributes['postLayout'] === 'grid' ? 'post-item gpl-mb-30 gpl-column-'
			                                                   . $attributes['columns'] . ''
				: 'post-item gpl-mb-30';

			$markup .= sprintf( '<article class="%1$s %2$s">', esc_attr( $gridView ), $attributes['gridLayoutStyle'] );

			// start the post content wrap
			$markup .= '<div class="post-content-area ' . $attributes['align'] . '">';
			$image = $attributes['post_type'] === 'attachment' ? $post['guid'] : wp_get_attachment_image_src( $post_thumbnail_id, '' . $attributes['postImageSizes'] . '', false)[0];
			if ( $attributes['displayPostImage'] && $image ) {
				$markup .= sprintf( '<div class="post-image"><a href="%1$s" target="_blank" rel="bookmark"><img src="%2$s"/></a></div>',
					esc_url( get_permalink( $post_id ) ),
					$image
				);
			}

			// start the inner post content wrap
			$markup .= '<div class="gpl-inner-post-content">';

			// start the post meta wrap
			$markup .= '<div class="post-meta">';

			if ( isset( $attributes['displayPostAuthor'] ) && $attributes['displayPostAuthor']
			     && $attributes['gridLayoutStyle'] !== 'g_skin2'
			) {
				$markup .= sprintf(
					'<a target="_blank" href="%2$s">%1$s</a>',
					esc_html( get_the_author_meta( 'display_name', $post['post_author'] ) ),
					esc_url( get_author_posts_url( get_author_posts_url( $post['post_author'] ) ) )
				);
			}

			if ( isset( $attributes['displayPostDate'] ) && $attributes['displayPostDate'] ) {
				$markup .= sprintf(
					'<time datetime="%1$s">%2$s</time>',
					esc_attr( get_the_date( 'c', $post_id ) ),
					esc_html( get_the_date( '', $post_id ) )
				);
			}

			$markup .= '</div>';
			// close the post meta wrap

			// start the post title wrap
			$markup .= sprintf( '<h2 class="post-title"><a href="%1$s" target="_blank" rel="bookmark">%2$s</a></h2>',
				esc_url( get_permalink( $post_id ) ),
				esc_html( get_the_title( $post_id ) ) );
			// close the post title wrap

			// start the post excerpt wrap
			$content = get_the_excerpt( $post_id );
			if ( $content && $attributes['displayPostExcerpt'] && $attributes['gridLayoutStyle'] !== 'g_skin2') {
				$markup .= sprintf( ' <div class="post-excerpt"><div><p>%1$s</p></div></div>',
					wp_kses_post( $content )
				);
			}
			// close the post excerpt wrap

			// start the post read more wrap
			if ( isset( $attributes['displayPostReadMoreButton'] ) && $attributes['displayPostReadMoreButton'] && $attributes['gridLayoutStyle'] !== 'g_skin2') {
				$markup .= sprintf( '<div><a class="post-read-moore" href="%1$s" target="_blank" rel="bookmark">%2$s</a></div>',
					esc_url( get_permalink( $post_id ) ), esc_html( $attributes['postReadMoreButtonText'] ) );
			}
			// close the post read more wrap

			$markup .= '</div>';
			$markup .= '<div class="gpl-overlay-effect"></div>';
			$markup .= '</div>';
			// close the post content wrap

			$markup .= '</article>';
			// close the post-item wrap
			$markup .= '</div>';
		}
		$parentClasses = $attributes['gridLayoutStyle'] === 'g_skin2' ? 'gpl-column-8 gpl-d-flex gpl-flex-wrap' : 'gpl-column-12 gpl-d-flex gpl-flex-wrap';
		
		$markup .= '<div class="'.esc_attr($parentClasses).'">';
		foreach ( $recent_posts as $post ) {
			$post_id = $post['ID'];
			$post_thumbnail_id = get_post_thumbnail_id( $post_id );

			$gridView = $attributes['postLayout'] === 'grid' ? 'post-item gpl-mb-30 gpl-column-'
			                                                   . $attributes['columns'] . ''
				: 'post-item gpl-mb-30';

			// start the post-item wrap
			$markup .= sprintf( '<article class="%1$s %2$s">', esc_attr( $gridView ), $attributes['gridLayoutStyle'] );
			// start the post content wrap
			$markup .= '<div class="post-content-area ' . $attributes['align'] . '">';
			$image = $attributes['post_type'] === 'attachment' ? $post['guid'] : wp_get_attachment_image_src( $post_thumbnail_id, '' . $attributes['postImageSizes'] . '', false)[0];
			if ( $attributes['displayPostImage'] && $image ) {
				$markup .= sprintf( '<div class="post-image"><a href="%1$s" target="_blank" rel="bookmark"><img src="%2$s"/></a></div>',
					esc_url( get_permalink( $post_id ) ),
					$image
				);
			}

			// start the inner post content wrap
			$markup .= '<div class="gpl-inner-post-content">';

			// start the post meta wrap
			$markup .= '<div class="post-meta">';

			if ( isset( $attributes['displayPostAuthor'] ) && $attributes['displayPostAuthor']
			     && $attributes['gridLayoutStyle'] !== 'g_skin2'
			) {
				$markup .= sprintf(
					'<a target="_blank" href="%2$s">%1$s</a>',
					esc_html( get_the_author_meta( 'display_name', $post['post_author'] ) ),
					esc_url( get_author_posts_url( get_author_posts_url( $post['post_author'] ) ) )
				);
			}

			if ( isset( $attributes['displayPostDate'] ) && $attributes['displayPostDate'] ) {
				$markup .= sprintf(
					'<time datetime="%1$s">%2$s</time>',
					esc_attr( get_the_date( 'c', $post_id ) ),
					esc_html( get_the_date( '', $post_id ) )
				);
			}

			$markup .= '</div>';
			// close the post meta wrap

			// start the post title wrap
			$markup .= sprintf( '<h2 class="post-title"><a href="%1$s" target="_blank" rel="bookmark">%2$s</a></h2>',
				esc_url( get_permalink( $post_id ) ),
				esc_html( get_the_title( $post_id ) ) );
			// close the post title wrap

			// start the post excerpt wrap
			$content = get_the_excerpt( $post_id );
			if ( $content && $attributes['displayPostExcerpt'] && $attributes['gridLayoutStyle'] !== 'g_skin1'
			     && $attributes['gridLayoutStyle'] !== 'g_skin2'
			) {
				$markup .= sprintf( ' <div class="post-excerpt"><div><p>%1$s</p></div></div>',
					wp_kses_post( $content )
				);
			}
			// close the post excerpt wrap

			// start the post read more wrap
			if ( isset( $attributes['displayPostReadMoreButton'] ) && $attributes['displayPostReadMoreButton']
			     && $attributes['gridLayoutStyle'] !== 'g_skin1'
			     && $attributes['gridLayoutStyle'] !== 'g_skin2'
			) {
				$markup .= sprintf( '<div><a class="post-read-moore" href="%1$s" target="_blank" rel="bookmark">%2$s</a></div>',
					esc_url( get_permalink( $post_id ) ), esc_html( $attributes['postReadMoreButtonText'] ) );
			}
			// close the post read more wrap

			$markup .= '</div>';
			$markup .= '<div class="gpl-overlay-effect"></div>';
			$markup .= '</div>';
			// close the post content wrap

			$markup .= '</article>';
			// close the post-item wrap
		}
		$markup .= '</div>';
		$markup .= '</div>';
	}
	
	return $markup;
}

function guten_post_layout_register_post_grid(){
	
	if( !function_exists('register_block_type') ){
		return;
	}

	register_block_type( 'guten-post-layout/post-grid', array(
		'attributes' => array(
			'postBlockWidth' => array(
				'type' => 'string',
			),
			'align' => array(
				'type' => 'string',
				'default' => 'left',
			),
			'post_type' => array(
				'type' => 'string',
				'default' => 'post'
			),
			'categories' => array(
				'type' => 'string',
			),
			'team_cats' => array(
				'type' => 'string',
			),
			'postscount' => array(
				'type' => 'number',
				'default' => 5,
			),
			'order' => array(
				'type' => 'string',
				'default' => 'desc',
			),
			'orderBy'  => array(
				'type' => 'string',
				'default' => 'date',
			),
			'columns' => array(
				'type' => 'number',
				'default' => 2
			),
			'columnGap' => array(
				'type' => 'number',
				'default' => 15
			),
			'postLayout' => array(
				'type' => 'string',
				'default' => 'grid',
			),
			'carouselLayoutStyle' => array(
				'type' => 'string',
				'default' => 'skin1',
			),
			'slidesToShow' => array(
				'type' => 'number',
				'default' => 2,
			),
			'autoPlay' => array(
				'type' => 'boolen',
				'default' => true
			),
			'navigation' => array(
				'type' => 'string',
				'default' => 'dots'
			),
			'gridLayoutStyle' => array(
				'type' => 'string',
				'default' => 'g_skin1',
			),
			'postImageSizes' => array(
				'type' => 'string',
				'default' => 'full',
			),
			'displayPostImage' => array(
				'type' => 'boolen',
				'default' => true
			),
			'displayPostDate' => array(
				'type' => 'boolean',
				'default' => true,
			),
			'displayPostAuthor' => array(
				'type' => 'boolean',
				'default' => true,
			),
			'displayPostExcerpt' => array(
				'type' => 'boolean',
				'default' => true,
			),
			'displayPostReadMoreButton' => array(
				'type' => 'boolean',
				'default' => true,
			),
			'postReadMoreButtonText' => array(
				'type' => 'string',
				'default' => 'Read More',
			),
		),
		'render_callback' => 'guten_post_layout_render_post_grid',
	));
	
	
}
add_action( 'init', 'guten_post_layout_register_post_grid' );

/**
 * Create API fields for additional info
 */

function guten_post_layout_register_rest_fields() {
	$post_types = get_post_types();
	
	register_rest_field(
		$post_types,
		'guten_post_layout_featured_media_urls',
		array(
			'get_callback' => 'get_guten_post_layout_featured_media',
			'update_callback' => null,
			'schema' => array(
				'description' => __( 'Different Sized Featured Images', 'guten-post-layout'),
				'type' => 'array'
			)
		)
	);
	
}

add_action('rest_api_init', 'guten_post_layout_register_rest_fields');

function get_guten_post_layout_featured_media($object){
	$featured_media = wp_get_attachment_image_src( $object['featured_media'], 'full', false );
	
	return array(
		'thumbnail' => is_array($featured_media) ? wp_get_attachment_image_src(
			$object['featured_media'],
			'thumbnail',
			false
		) : '',
		'guten_post_layout_landscape_large' => is_array($featured_media) ? wp_get_attachment_image_src(
			$object['featured_media'],
			'guten_post_layout_landscape_large',
			false
		) : '',
		'guten_post_layout_portrait_large' => is_array($featured_media) ? wp_get_attachment_image_src(
			$object['featured_media'],
			'guten_post_layout_portrait_large',
			false
		) : '',
		'guten_post_layout_square_large' => is_array($featured_media) ? wp_get_attachment_image_src(
			$object['featured_media'],
			'guten_post_layout_square_large',
			false
		) : '',
		'guten_post_layout_landscape' => is_array($featured_media) ? wp_get_attachment_image_src(
			$object['featured_media'],
			'guten_post_layout_landscape',
			false
		) : '',
		'guten_post_layout_portrait' => is_array($featured_media) ? wp_get_attachment_image_src(
			$object['featured_media'],
			'guten_post_layout_portrait',
			false
		) : '',
		'guten_post_layout_square' => is_array($featured_media) ? wp_get_attachment_image_src(
			$object['featured_media'],
			'guten_post_layout_square',
			false
		) : '',
		'full' => is_array($featured_media) ? $featured_media : '',
	);
	
}



/**
 * Add image sizes
 */
function guten_post_layout_image_sizes() {
	add_image_size( 'guten_post_layout_landscape_large', 1200, 800, true );
	add_image_size( 'guten_post_layout_portrait_large', 1200, 1800, true );
	add_image_size( 'guten_post_layout_square_large', 1200, 1200, true );
	add_image_size( 'guten_post_layout_landscape', 600, 400, true );
	add_image_size( 'guten_post_layout_portrait', 600, 900, true );
	add_image_size( 'guten_post_layout_square', 600, 600, true );
}
add_action( 'after_setup_theme', 'guten_post_layout_image_sizes' );




