<?php
/*
Element Description: Rs Services Box
*/
    // Element Mapping
     function vc_RsServices_mapping() {
         
        // Stop all if VC is not enabled
        if ( !defined( 'WPB_VC_VERSION' ) ) {
            return;
        }
         
        // Map the block with vc_map()
        vc_map( 
            array(
                'name' => __('Rs Service Box', 'bstart'),
                'base' => 'vc_RsServices',
                'description' => __('Rs Service Box Information', 'bstart'), 
                'category' => __('by RS Theme', 'bstart'),   
                'icon' => get_template_directory_uri().'/framework/assets/img/vc-icon.png',           
                'params' => array(   
                         
                    array(
                        'type' => 'textfield',
                        'holder' => 'h3',
                        'class' => 'title-class',
                        'heading' => __( 'Rs Service Title ', 'bstart' ),
                        'param_name' => 'title',
                        'value' => __( '', 'bstart' ),
                        'description' => __( 'Rs services title here', 'bstart' ),
                        'admin_label' => false,
                        'weight' => 0,
                       
                    ),                   
             				
					array(
						"type" => "textarea_html",
						"holder" => "div",
						"class" => "",
						"heading" => __( "Services content here", "bstart" ),
						"param_name" => "content", // Important: Only one textarea_html param per content element allowed and it should have "content" as a 	"param_name"
						"value" =>'',
						"description" => __( "Duis in mi erat. Phasellus vitae in to lorem vehicula, viverra libero quis, sodalesnulla. Donec at the turpis quis tellus laoreet.", "bstart" )
					 ),
					 
					 array(
						"type" => "dropdown",
						"heading" => __("Select Sevices Style", "bstart"),
						"param_name" => "service_style",
						"value" => array(						    
							'Style 1' => "Style 1",						
							'Style 2' => "Style 2", 
							 																																															
						),						
					),					 
					
					 array(
							"type"        => "attach_image",
							"heading"     => __( "Service Image", "bstart" ),
							"description" => __( "Add services image", "bstart" ),
							"param_name"  => "screenshots",
							"value"       => "",
							"dependency" => Array('element' => 'service_style', 'value' => array('Style 2')),
						),				
					
									
					array(
						'type' => 'dropdown',
						'heading' => __( 'Icon library', 'bstart' ),
						'value' => array(
							__( 'Font Awesome', 'bstart' ) => 'fontawesome',
							__( 'Open Iconic', 'bstart' ) => 'openiconic',
							__( 'Typicons', 'bstart' ) => 'typicons',
							__( 'Entypo', 'bstart' ) => 'entypo',
							__( 'Linecons', 'bstart' ) => 'linecons',
							__( 'Mono Social', 'bstart' ) => 'monosocial',
							__( 'Material', 'bstart' ) => 'material',
						),
						'admin_label' => true,
						'param_name' => 'type',
						"dependency" => Array('element' => 'service_style', 'value' => array('Style 1')),
						'description' => __( 'Select icon library.', 'bstart' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'bstart' ),
						'param_name' => 'icon_fontawesome',
						'value' => 'fa fa-users',
						// default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false,
							// default true, display an "EMPTY" icon?
							'iconsPerPage' => 4000,
							// default 100, how many icons per/page to display, we use (big number) to display all icons in single page
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'fontawesome',
						),
						'description' => __( 'Select icon from library.', 'bstart' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'bstart' ),
						'param_name' => 'icon_openiconic',
						'value' => 'vc-oi vc-oi-dial',
						// default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false,
							// default true, display an "EMPTY" icon?
							'type' => 'openiconic',
							'iconsPerPage' => 4000,
							// default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'openiconic',
						),
						'description' => __( 'Select icon from library.', 'bstart' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'bstart' ),
						'param_name' => 'icon_typicons',
						'value' => 'typcn typcn-adjust-brightness',
						// default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false,
							// default true, display an "EMPTY" icon?
							'type' => 'typicons',
							'iconsPerPage' => 4000,
							// default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'typicons',
						),
						'description' => __( 'Select icon from library.', 'bstart' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'bstart' ),
						'param_name' => 'icon_entypo',
						'value' => 'entypo-icon entypo-icon-note',
						// default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false,
							// default true, display an "EMPTY" icon?
							'type' => 'entypo',
							'iconsPerPage' => 4000,
							// default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'entypo',
						),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'bstart' ),
						'param_name' => 'icon_linecons',
						'value' => 'vc_li vc_li-heart',
						// default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false,
							// default true, display an "EMPTY" icon?
							'type' => 'linecons',
							'iconsPerPage' => 4000,
							// default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'linecons',
						),
						'description' => __( 'Select icon from library.', 'bstart' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'bstart' ),
						'param_name' => 'icon_monosocial',
						'value' => 'vc-mono vc-mono-fivehundredpx',
						// default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false,
							// default true, display an "EMPTY" icon?
							'type' => 'monosocial',
							'iconsPerPage' => 4000,
							// default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'monosocial',
						),
						'description' => __( 'Select icon from library.', 'bstart' ),
					),
					array(
						'type' => 'iconpicker',
						'heading' => __( 'Icon', 'bstart' ),
						'param_name' => 'icon_material',
						'value' => 'vc-material vc-material-cake',
						// default value to backend editor admin_label
						'settings' => array(
							'emptyIcon' => false,
							// default true, display an "EMPTY" icon?
							'type' => 'material',
							'iconsPerPage' => 4000,
							// default 100, how many icons per/page to display
						),
						'dependency' => array(
							'element' => 'type',
							'value' => 'material',
						),
						'description' => __( 'Select icon from library.', 'bstart' ),
					),
					
					array(
						'type' => 'vc_link',
						'heading' => __( 'URL (Link)', 'bstart' ),
						'param_name' => 'button_link',
						'description' => __( 'Add link to Serices Pages.', 'bstart' ),						
					),
												
					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => __( "Title color", "bstart" ),
						"param_name" => "titlecolor",
						"value" => '#212121', //Default Red color
						"description" => __( "Choose color", "bstart" ),
						'admin_label' => false,
                        'weight' => 0,
                        'group' => 'Style',
					 ),				 
					
					array(
							'type' => 'textfield',
							'heading' => __( 'Extra class name', 'bstart' ),
							'param_name' => 'el_class',
							'description' => __( 'Style particular content element differently - add a class name and refer to it in custom CSS.', 'bstart' ),
						),	
					
					array(
					'type' => 'css_editor',
					'heading' => __( 'CSS box', 'bstart' ),
					'param_name' => 'css',
					'group' => __( 'Design Options', 'bstart' ),
				),            
                        
                ),
				
					
            )
        );                                
        
    }
     
  add_action( 'vc_before_init', 'vc_RsServices_mapping' );
     
    
    // Element HTML
    function vc_RsServices_html( $atts,$content ) {

  

         $attributes = array();
        // Params extraction
        extract(
            shortcode_atts(
                array(
					'title'            => '',
					'type'        => '',					
					'icon_fontawesome' => '',
					'icon_openiconic'  => '',
					'icon_typicons'    => '',
					'icon_entypo'      => '',
					'icon_linecons'    => '',
					'icon_monosocial'  => '',
					'icon_material'    => '',
					'icon'             => 'Image',					
					'titlecolor'       => '',
					'text_font'        => '',
					'el_class'         =>'',
					'service_style'    => 'Style 1',
					'button_link'      => '',
					'css'              => '','vc_RsServices'
                ), 
                $atts,'vc_RsServices'
            )
        );

	
        $a = shortcode_atts(array(
          'screenshots' => 'screenshots',
        ), $atts);
           
		// Enqueue needed icon font.
		vc_icon_element_fonts_enqueue( $type );
		
		//parse link for vc linke		
		$button_link = ( '||' === $button_link ) ? '' : $button_link;
		$button_link = vc_build_link( $button_link );
		$use_link = false;
		if ( strlen( $button_link['url'] ) > 0 ) {
			$use_link = true;
			$a_href = $button_link['url'];
			$a_title = $button_link['title'];
			$a_target = $button_link['target'];
		}
		
		if ( $use_link ) {
			$attributes[] = 'href="' . esc_url( trim( $a_href ) ) . '"';
			$attributes[] = 'title="' . esc_attr( trim( $a_title ) ) . '"';
			if ( ! empty( $a_target ) ) {
				$attributes[] = 'target="' . esc_attr( trim( $a_target ) ) . '"';
			}
		}
		$attributes = implode( ' ', $attributes );
		
	

		if($icon_fontawesome != ''):
		  $services_icon = esc_attr($icon_fontawesome);
		endif;

		if ($icon_openiconic != ''):
			$services_icon = esc_attr($icon_openiconic);
		endif;

		if ($icon_typicons != ''):
			$services_icon = esc_attr($icon_typicons);
		endif;

		if ($icon_entypo != ''):
			$services_icon = esc_attr($icon_entypo);
		endif;

		if ($icon_linecons != ''):
			$services_icon = esc_attr($icon_linecons);
		endif;

		if ($icon_monosocial != ''):
			$services_icon = esc_attr($icon_monosocial);
		endif;
		
		if ($icon_material != ''):
			$services_icon = esc_attr($icon_material);
		endif;
		
        $img = wp_get_attachment_image_src($a["screenshots"], "large");

        $imgSrc = $img[0];

        if ($imgSrc) {
			$imageClass='<img src="'.$imgSrc.'" alt="Rs-service" />';
        }else{
        	$imageClass= "";
        }
				
		//extract content
		$atts['content'] = $content;

		//extract css edit box
		$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, vc_shortcode_custom_css_class( $css, ' ' ), $atts );
		
		 //custom class added
		$wrapper_classes = array($el_class) ;			
		$class_to_filter = implode( ' ', array_filter( $wrapper_classes ) );		
		$css_class_custom = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $class_to_filter, $atts );
  
		
        //checking services style
                
        // Fill $html var with data
		if($service_style == 'Style 1')
		{
        $html = '
		<div class="rs-services1">
		<div class="services-wrap '.$css_class.' '.$css_class_custom.'"> 
         <div class="services-item">
            <div class="services-icon">
                <i class="vc_icon_element-icon '.$services_icon.'"></i>
             </div>
        
			<div class="services-desc">
				<h2 class="services-title"><a '. $attributes.'>'.$title.'</a></h2>
				'.$atts['content'].' 
				</div>
			</div>	
		</div></div>
	';   	
  	return $html;
	}
	else{
		$html = '<div class="rs-services"><div class="service-inner services-style-2 '.$css_class.' '.$css_class_custom.'">
		<div class="services-wrap"> 
         <div class="services-item">
            <div class="services-icon">
                '.$imageClass.'
             </div>
        
		<div class="services-desc">	
		<h2 class="services-title services-title2"><a '. $attributes.'>'.$title.'</a></h2>		
			'.$atts['content'].' 
		</div>		
		</div>	
	</div>
	</div></div>';   	
  		return $html;
	}
 }
add_shortcode( 'vc_RsServices', 'vc_RsServices_html' );
 